/*
**
*******************************************************************************
**
**
**				Copyright (c) 2004 - Atmel Corporation
**				L
**
** 	: グݍݖh~
** 	:
** 	: LINʐM`̧(LINdlV1.3K)
**
** :		t:			:		:
**			2006N810	F.G			쐬
**
**  -
**
** ATMEL - 2004-2005
** SĂ̿ĳ ۸т͂ǂ̎̕ۏ؂Ȃ'󂻂̂܂'Œ񋟂܂BATMEL
** ͂ǂ̖ړIɑ΂Ă񋟂ꂽޗ̓K錾܂BATMEL͑SĂ̈Î
** Iȕۏ؁A̖ړIA\ANQɑ΂K܂݁A񋟂ꂽĳ
** ɊւSĂ̕ۏ؂Əłf肵܂B@Ȃĳ ۸т̎gp
** ̌ʂAǂȊԐړI܂͌ʂƂċN鑹Q≽̑QATMEL͌
** ӔCȂł傤B
*******************************************************************************
**
*/

#ifndef _LDF_WINDOW_LIFT_H
#define _LDF_WINDOW_LIFT_H

void init_schedule(void);
void upload_eeprom_parameters(void);

//*****************************************************************************
// CMD_SLAVE FRAME ////////////////////////////////////////////////////////////
//*****************************************************************************
#define CMD_SLAVE_FRAME_ID		0x03
#define CMD_SLAVE_FRAME_DLC		4
#define CMD_SLAVE_FRAME_TYPE	0		// 0:ڰтŉpȂ, 1:]uv

//----- 擪޲Ē`
#define CMD_DOWNWARD			2
#define CMD_DOWNWARD_OFFSET		2
#define CMD_DOWNWARD_LEN		1
#define CMD_DOWNWARD_MASK		0x04

#define CMD_UPWARD				3
#define CMD_UPWARD_OFFSET		3
#define CMD_UPWARD_LEN			1
#define CMD_UPWARD_MASK			0x08

#define CMD_DLOAD_PARAMS		7		// EEPROMҰDLOADv̈
#define CMD_DLOAD_PARAMS_OFFSET	7
#define CMD_DLOAD_PARAMS_LEN	1
#define CMD_DLOAD_PARAMS_MASK	0x80

//------ 2޲Ē`
#define CMD_DLOAD_COUNT			0		// v̈:Ұv
#define CMD_DLOAD_COUNT_OFFSET	0
#define CMD_DLOAD_COUNT_LEN		4
#define CMD_DLOAD_COUNT_MASK	0x0F

//------ 3yё4޲Ē`
#define CMD_DLOAD_DATA1			0
#define CMD_DLOAD_DATA1_LEN		8
#define CMD_DLOAD_DATA1_MASK	0xFF

#define CMD_DLOAD_DATA2			0
#define CMD_DLOAD_DATA2_LEN		8
#define CMD_DLOAD_DATA2_MASK	0xFF

// /
#define CMD_INACTIVE			0
#define CMD_ACTIVE				1

// ̈`
#define DLOAD_NO_REQ			0		// CMD_DLOAD_PARAMSl`
#define DLOAD_REQ				1

extern U8 cmd_slave_buffer[];			// 񖽗ڰ ްpްɏՕ

#define CMD_LIN_GET_UPWARD()		(CMD_ACTIVE == (cmd_slave_buffer[0] & \
									 CMD_UPWARD_MASK) >> CMD_UPWARD_OFFSET)

#define CMD_LIN_GET_DOWNWARD()		(CMD_ACTIVE == (cmd_slave_buffer[0] & \
									 CMD_DOWNWARD_MASK) >> CMD_DOWNWARD_OFFSET)

#define CMD_LIN_GET_DLOAD_COUNT()	((cmd_slave_buffer[1] & CMD_DLOAD_COUNT_MASK)\
									 << CMD_DLOAD_COUNT_OFFSET)
#define CMD_LIN_GET_DLOAD_REQ()		((cmd_slave_buffer[0] & CMD_DLOAD_PARAMS_MASK)\
									 << CMD_DLOAD_PARAMS_OFFSET)

#define CMD_GET_DLOAD_DATA1()		(cmd_slave_buffer[2])
#define CMD_GET_DLOAD_DATA2()		(cmd_slave_buffer[3])

//**************************************************************************
// LIN]u0ڰю擾
//**************************************************************************
#define GET_SLAVE_0_FRAME_ID		0x00
#define GET_SLAVE_0_FRAME_DLC		4
#define GET_SLAVE_0_FRAME_TYPE		1	// 0:ڰщpȂ, 1: ]uv

// 擪޲
#define GET_CURRENT_LSB				0   // d@d̉޲ď
#define GET_CURRENT_LSB_OFFSET		0
#define GET_CURRENT_LSB_LEN			8
#define GET_CURRENT_LSB_MASK		0xFF

// 2޲
#define GET_CURRENT_MSB				0   // d@d̏޲ď
#define GET_CURRENT_MSB_OFFSET		0
#define GET_CURRENT_MSB_LEN			2
#define GET_CURRENT_MSB_MASK		0x03

#define GET_SLAVE_0_UNUSED			2
#define GET_SLAVE_0_UNUSED_LEN		2
#define GET_SLAVE_0_UNUSED_MASK		0x0C

#define GET_SLAVE_WL_STATUS			4	// グo
#define GET_SLAVE_WL_STATUS_OFFSET	4
#define GET_SLAVE_WL_STATUS_LEN		4
#define GET_SLAVE_WL_STATUS_MASK	0xF0

// 3޲
#define GET_DLOAD_COUNT				0
#define GET_DLOAD_COUNT_OFFSET		0
#define GET_DLOAD_COUNT_LEN			4
#define GET_DLOAD_COUNT_MASK		0x0F

extern U8 Get_slave_0_buffer[];		// ڰ0ް擾镶pްɏՕ

// ϸ
#define SET_LIN_MOT_CURRENT(current)	(Get_slave_0_buffer[0] = \
										(U8)(current & GET_CURRENT_LSB_MASK), \
										Get_slave_0_buffer[1] = \
										(Get_slave_0_buffer[1] & ~GET_CURRENT_MSB_MASK) \
										| ((current >> 8) & GET_CURRENT_MSB_MASK) )

#define SET_LIN_AP_STATE(state)			(Get_slave_0_buffer[1] = \
										(Get_slave_0_buffer[1] & ~GET_SLAVE_WL_STATUS_MASK) \
										| ((state << GET_SLAVE_WL_STATUS_OFFSET) \
										& GET_SLAVE_WL_STATUS_MASK))

#define ACK_LIN_DLOAD_COUNT(count)		(Get_slave_0_buffer[2] = \
										(Get_slave_0_buffer[2] & ~GET_DLOAD_COUNT_MASK) \
										| ((count << GET_DLOAD_COUNT_OFFSET)&GET_DLOAD_COUNT_MASK))

#endif //_LDF_WINDOW_LIFT_H
