//! @file $RCSfile: master_lin.h,v $
//!
//! Copyright (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧قCĳ ۸яp̐`łB
//!
//! ̐`̧ق͎pDoxygenɂĉ͂邱Ƃł܂B
//! Ȃ۸т̿ĳ\ł̧̂ق̋@\ɒuĂB
//!
//! @version $Revision: 1.1.1.1 $ $Name: First_Release $ $Id: master_lin.h,v 1.1.1.1 2006/07/27 09:39:53 gallain Exp $
//!
//! @todo
//! @bug

#ifndef MASTER_LIN_H
#define MASTER_LIN_H

//_____ ݸٰ ________________________________________________________________
#include "config.h"
#include "lib_mcu/lin_uart/lin_lib.h"
#include "lib_mcu/lin_uart/lin_drv_usart.h"

//_____ ϸ ____________________________________________________________________

// /1ޯĎԐݒl
#if LIN_BAUDRATE == 2400
	#define _8MHZ_TCNT1H			0xF3
	#define _8MHZ_TCNT1L			0x00
	#define _8_BIT_TIMER_PRESCALER	64
	#define _8_BIT_TIMER_SEED		204
#elif LIN_BAUDRATE == 4800
	#define _8MHZ_TCNT1H			0xF9
	#define _8MHZ_TCNT1L			0x80
#elif LIN_BAUDRATE == 9600
	#define _8MHZ_TCNT1H			0xFC
	#define _8MHZ_TCNT1L			0xC0
	#define _8_BIT_TIMER_PRESCALER	8
	#define _8_BIT_TIMER_SEED		152
#elif LIN_BAUDRATE == 19200
	#define _8MHZ_TCNT1H			0xFE
	#define _8MHZ_TCNT1L			0x60
	#define _8_BIT_TIMER_PRESCALER	8
	#define _8_BIT_TIMER_SEED		204
#else
	#error	" LIN BAUDRATE NOT SUPPORTED "
#endif

#define ASCII_NUM_OFFSET			48
#define SLEEP_TIMOUT				25000
#define NB_FRAME					8
#define FALSE						0
#define TRUE						1
#define REMOTE_LIN_FRAME_TYPE		1				// 呕uM(擪)+呕uM()
#define STANDART_LIN_FRAME_TYPE		0				// 呕uM(擪+)

//_____ 錾 ___________________________________________________________________

//!< LINڰэ\
typedef struct  {
  U8 frame_id;								//!< ڰюʎq
  U8 frame_size;							//!< ڰїe
  U8 * frame_data;							//!< ڰ ް̈ʒuwq
  U8 frame_type;							//!< ݒ肳ꂽꍇAڰщłڰь`
  U16 frame_delay;							//!< ڰёoOҋ@(TBITł̒x)
  U8 data_has_changed;						//!< ްύX
} t_frame;

//!< LINv敔\
typedef struct  {
  U8 number_of_frame;						//!< vłڰѐ
  t_frame frame_message[NB_FRAME];			//!< ڰт̈o
} t_schedule;

extern t_schedule my_schedule ;				// ݂̌v
extern U8 tab_data[8];						// LINްɏՕ
extern U8 Frame_index;						// ڰшʒuwq

#ifdef _SLEEP_TIMOUT_DETECTION
	extern U8 LINSleepFlag;					// LINx~׸
	extern U8 lin_sleep_message_request;	// Lʎ呕uvł̋x~ߗv׸
#endif

#ifdef _COUNTING_ERRORS_ENABLE
	extern U16 countCERR;					// ьv
	extern U16 countRERR;					// ]uُv(呕û)
	extern U16 countBERR;					// ޯĈُv
	extern U16 countSERR;					// ُv
	extern U16 countPERR;					// èv
#endif

#ifdef CAN_LIN_GATEWAY_ENABLE
	extern volatile U8 SendCanErrorFrame;	// CANُڰёMv׸
	extern volatile U8 LinErrorMessage;		// LINُ
#endif

void LIN_TIMER_init (void);
void DataRequest_Notification(U8 ReceivedId,U8 ReceivedSize);
void Start_Lin_Master (void);
U8 DataReceived_Notification(U8 ReceivedId,U8 ReceivedSize);
U8 l_sch_tick(void);						// ޯĎԒPʽޭ׊Ǘ
U8 id_to_dlc (U8 lin_id);
U8 ComputeIdField(U8 lin_id_wo_dlc,U8 dlc)  ;
U8 CompDataBuffer(U8 * Buffer1, U8 * Buffer2,U8 BufferSize);
char int2hex(unsigned char integer) ;

#ifdef _COUNTING_ERRORS_ENABLE
void update_error_counter(U8 status);
#endif

#endif /* end #ifndef MASTER_LIN_H */
