/*H****************************************************************************
* $RCSfile: uartnoint_lib.h,v $
*------------------------------------------------------------------------------
* Copyright (c) 2003 Atmel.
*------------------------------------------------------------------------------
* J			: $Name:  $
* 			: $Revision: 1.1 $
* FILE_CVSID	: $Id: uartnoint_lib.h,v 1.1 2003/07/04 13:17:57 jberthy Exp $
*------------------------------------------------------------------------------
* ړI			: ̧قFROYApɏo͂SĂ̌^ϸۂ܂݂܂B
*				  ̐`̧ق͎plangdocɂĉ͂ł܂B
*******************************************************************************/

#ifndef _UARTNOINT_LIB_H_
#define _UARTNOINT_LIB_H_

/*_____ ݸٰ ̧ ________________________________________________________*/

/*_____ 萔` ____________________________________________________________*/

#define XTAL_CPU_1		   1000000	//		1 MHz
#define XTAL_CPU_2		   2000000	//		2 MHz
#define XTAL_CPU_4		   4000000	//		4 MHz
#define XTAL_CPU_8		   8000000	//		8 MHz
#define XTAL_CPU_10		  10000000	//	   10 MHz
#define XTAL_CPU_12		  12000000	//	   12 MHz
#define XTAL_CPU_16		  16000000	//	   16 MHz

#define BAUD_RATE_2400		  2400	//  2400  bps
#define BAUD_RATE_4800		  4800	//  4800  bps
#define BAUD_RATE_9600		  9600	//  9600  bps
#define BAUD_RATE_14K4		 14400	//  14.4 kbps
#define BAUD_RATE_19K2		 19200	//  19.2 kbps
#define BAUD_RATE_28K8		 28800	//  28.8 kbps - 1MHzł̍ől
#define BAUD_RATE_38K4		 38400	//  38.4 kbps 
#define BAUD_RATE_57K6		 57600	//  57.6 kbps - 2MHzł̍ől
#define BAUD_RATE_76K8		 76800	//  76.8 kbps
#define BAUD_RATE_115K2		115200	// 115.2 kbps

/*_____ ϸے` _____________________________________________________________*/

#define UART_BAUD(baudrate,xtalcpu) (Uint16)((xtalcpu/(((Uint32)(baudrate))*16))-1)

/*_____ ^錾 ____________________________________________________________*/

extern void InitUART_0 (Uint16 baud);
extern void InitUART_1 (Uint16 baud);

extern Uchar GetCharUART_0 (void);
extern Uchar GetCharUART_1 (void);

extern void PutCharUART_0 (Uchar);
extern void PutCharUART_1 (Uchar);

extern void CPrintfUART_0 (const Uchar *cstring);
extern void CPrintfUART_1 (const Uchar *cstring);

extern void DPrintfUART_0 (Uchar *cstring);
extern void DPrintfUART_1 (Uchar *cstring);

#endif  /* UARTNOINT_LIB_H */
