//! @file $RCSfile: lin_drv_usart.c,v $
//!
//! Copyright (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧قCĳ ۸яp̐`łB
//!
//! ̐`̧ق͎pDoxygenɂĉ͂邱Ƃł܂B
//! Ȃ۸т̿ĳ\ł̧̂ق̋@\ɒuĂB
//!
//! @version $Revision: 1.1.1.1 $ $Name: First_Release $ $Id: lin_drv_usart.c,v 1.1.1.1 2006/07/27 09:39:53 gallain Exp $
//!
//! @todo Test todo
//! @bug Test bug

//_____ ݸٰ ________________________________________________________________
#include "config.h"
#include "lin_drv_usart.h"
//_____ ϸ ____________________________________________________________________

//_____ ` ___________________________________________________________________
#if LIN_CONFIG == 0							// 1:]u, 0:呕u
	volatile  U8 lin_master_in_sleep_mode;	//!< x~Ԓߔ׸(呕u`Ԃł̎gp̂)
#endif

#ifdef _RUN_TIME_RC_CALIBRATION_ENABLE
	extern volatile U8 _lin_synchronized;  	//!< LIN͎呕uۯƓ܂B
	extern volatile U8 osccal_start;		//!< OSCCALJnl(main֐̎n߂Őݒ肵Ȃ΂Ȃ܂B:osccal_start = OSCAL)
#endif

//!
//! @defgroup lin_sm_definition LINԋ@\`
//!
//! @{
volatile U8  _lin_id;			//!< è ޯĂʎq
volatile U8  _lin_id_w_parity;	//!< vZꂽè ޯĕtLIN1.3Ŏʎq
volatile U8  _lin_tab_data[8];	//!< 8޲ĂްɏՕ
volatile U8  _lin_index;		//!< ްɏՕ޲Čv
volatile U8  _lin_status;		//!< LINԋ@\̏
volatile U8  _lin_err;			//!< LINُ
volatile U8  _lin_state;		//!< LINԋ@\Ԕԍ
volatile U8  _lin_cmd;			//!< LIN݂̖
volatile U8  _lin_cpt;			//!< ްɏՕpʒuwq
volatile U16 _lin_crc;			//!< LIN
//! @}

//_____ 錾 ___________________________________________________________________

//! ̊荞݊֐LIN̏ԋ@\Ǘ܂B
//! e޲ĂɉĊĎ(M)޲Ăo޲ĂƓ̂ɎM荞݂gp܂B
//!
//! @warning :
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
#if defined(__ICCAVR__)
  #pragma vector=USART_RX_IT_vect
  __interrupt void _lin_it_uart_rx (void){
#elif defined(__AVR__)
  ISR(USART_RX_IT_vect){
#else
  #error "Compiler not supported!"
  void uart_rx_interrupt(void){
#endif
  switch (_lin_state)  {

  // --- STATE_CHECK_BREAK:
  //
  // ̏Ԃ͎Ə]̗ǔ`ԐݒŎgp܂B
  // ̒iK͗LȓfM/MꂽƂ𒲂ׂ܂B
  //
  // : 呕ułтvZA܂B
  //
  case STATE_CHECK_BREAK:
	if (0x00 == Uart_get_byte()){				// fŁA
	  Uart_set_baudrate(UART_BAUDRATE_NORM);	// USARTްڰĂʏpɕύX
#ifdef _RUN_TIME_RC_CALIBRATION_ENABLE
	  Start_Capturing();						// RCUZl擾
	  OSCCAL = osccal_start;					// RCUZlXV
#endif
	  switch(_lin_cmd){
	  case LIN_CF_S_TX:							// ]uMŁA
	  case LIN_CF_S_RX:							// ]uMŁA

#ifdef _TIMOUT_DETECTION
		Timer2_start(TIMEOUT_S_HEADER,0);		// 擪ԒߌvJn
#endif
		_lin_state = STATE_CHECK_SYNC;			// Ԕԍ𓯊ԂɕύX
		break;

	  case LIN_CF_M_TX:							// 呕uMŁA
	  case LIN_CF_M_RX:							// 呕uMŁA
		Uart_send_byte(0x55);					// M
		_lin_crc = LIN_CalcChecksum();			// ьvZ
		_lin_state = STATE_CHECK_SYNC;			// Ԕԍ𓯊ԂɕύX
		break;

	  default:
		_lin_state = STATE_CHECK_SYNC;			// Ԕԍ𓯊ԂɕύX
		break;
	  }
	}else{										// fȊOŁA
#ifdef _TIMOUT_DETECTION
	  Timer2_stop();							// 擪Ԓߌv~
#endif
	  _lin_state = STATE_CHECK_BREAK;			// Ԕԍ𓯊fԂɐݒ
	}
	break;

  // --- STATE_CHECK_SYNC:
  //
  // ̏Ԃ͎Ə]̗uŎgp܂B
  // ̒iK͗Lȓ޲ĂM/MꂽƂƍ܂B
  //
  // : 呕ułèvZAʎq܂B
  //
  case STATE_CHECK_SYNC:
	if ((0x55 == Uart_get_byte()) ){			// ŁA
	  switch(_lin_cmd){
	  case LIN_CF_M_TX:							// 呕uMŁA
	  case LIN_CF_M_RX:							// 呕uMŁA
		_lin_id_w_parity = LIN_InitIdField(_lin_id );	// èvZĎʎqɒǉ
		Uart_send_byte(_lin_id_w_parity);		// ʎq޲đM
		_lin_state = STATE_ID_TX;				// ԔԍʎqMԂɕύX
		break;
	  default:									// ][uŁA
		_lin_state = STATE_ID_RX;				// ԔԍʎqMԂɕύX
		break;
	  }
	}else{										// ȊOŁA
#ifdef _TIMOUT_DETECTION
	  Timer2_stop();							// 擪Ԓߌv~
#endif
	  _lin_state = STATE_CHECK_BREAK;			// Ԕԍ𓯊fԂɕύX
	  _lin_status = MSK_STATUS_ERR;
	  switch(_lin_cmd){
	  case LIN_CF_M_TX:							// 呕uMŁA
	  case LIN_CF_M_RX:							// 呕uMŁA
		_lin_err   = MSK_STATUS_ERRBIT;			// ޯĈُ׸ސݒ
		break;
	  default:									// ][uŁA
		_lin_err = MSK_STATUS_ERRSYNCHRO;		// ُ׸ސݒ
		break;
	  }
	}
	break;

  // --- STATE_ID_TX:
  /
  // ̏Ԃ͎呕ułgp܂B
  // ̒iKLINʎqMꂽƍ܂B
  //
  // : 呕uMłްMJn܂B
  //	   呕uMłްM֐؂ւAMްvZ܂B
  //
  case STATE_ID_TX:
	if (Uart_get_error()){						// ُLŁA
#ifdef _TIMOUT_DETECTION
	  Timer2_stop();							// 擪Ԓߌv~
#endif
	  _lin_err = MSK_STATUS_ERRBIT;				// ޯĈُ׸ސݒ
	  _lin_status = MSK_STATUS_ERR;				// ُ׸ސݒ
	  _lin_state = STATE_CHECK_BREAK;			// Ԕԍ𓯊fԂɕύX
	  Uart_set_baudrate(UART_BAUDRATE_SYNC);	// USARTްڰĂ𓯊pɕύX
	}else if((_lin_id_w_parity == Uart_get_byte())){	// ُȂŁA
	  switch (_lin_cmd){
	  case LIN_CF_M_TX:							// 呕uMŁA
		_lin_index = Lin_dlctonbyte(_lin_id);	// M޲Đ擾
		if (_lin_index){						// M޲ėLŁA
		  Uart_send_byte(_lin_tab_data[0x00]);	// ް擪޲đM
		  _lin_state = STATE_DATA_TX;			// ԔԍްMԂɕύX
		  _lin_index--;							// M޲Čv팸
		  _lin_cpt = 0x01;						// ɏՕʒuw평(Mp)
		}else{									// M޲ĂȂŁA
		  /* `ׂ */
		}
		break;

	  case LIN_CF_M_RX:							// 呕uMŁA
		_lin_state = STATE_DATA_RX;				// ԔԍްMԂɕύX
		_lin_cpt  = 0x00;						// ɏՕʒuw평(Mp)
		_lin_index = Lin_dlctonbyte(_lin_id);	// M޲Đ擾
		break;

	  default:
		break;
	  }
	}else{
#ifdef _TIMOUT_DETECTION
	  Timer2_stop();							// Ԓߌv~
#endif
	  _lin_state = STATE_CHECK_BREAK;			// Ԕԍ𓯊fԂɕύX
	  _lin_err = MSK_STATUS_ERRBIT;				// ޯĈُ׸ސݒ
	  _lin_status = MSK_STATUS_ERR;				// ُ׸ސݒ
	  Uart_set_baudrate(UART_BAUDRATE_SYNC);	// USARTްڰĂ𓯊pɕύX
	}
	break;

  // --- STATE_ID_RX:
  //
  // ̏Ԃ͏]呕ułgp܂B
  // ̒iK͗LȎʎqMꂽƂ؂܂B
  //
  // : MׂްvZ܂B
  //
  case STATE_ID_RX:
	_lin_id = Uart_get_byte();					// Mʎq޲Ď擾
#ifdef _TIMOUT_DETECTION
	Timer2_stop();								// Ԓߌv~
#endif
	if ((_lin_id != LIN_InitIdField(_lin_id)) || ( Uart_get_error() )){		// è܂ُ͑̈LŁA
	  _lin_err = MSK_STATUS_ERRPARITY;			// è׸ސݒ
	  _lin_status = MSK_STATUS_ERR;				// ُ׸ސݒ
	  _lin_state = STATE_CHECK_BREAK;			// Ԕԍ𓯊fԂɕύX
	  Uart_set_baudrate(UART_BAUDRATE_SYNC);	// USARTްڰĂ𓯊pɕύX
	}else{										// èƑُ̈ȂŁA
	  _lin_status = MSK_STATUS_IDOK;			// ʎq׸ސݒ
	  _lin_state = STATE_DATA_RX;				// ԔԍްMԂɕύX
	  _lin_cpt =0;								// ɏՕʒuw평
	  _lin_index = Lin_dlctonbyte(_lin_id);		// Mް ޲Đ擾
	}
	break;

  // --- STATE_DATA_RX:
  //
  // ̏Ԃ͎Ə]̗uŎgp܂(]ƕ)B
  // ̒iK͂ėްꎞɏՕɊi[܂B
  //
  // : i[޲ĐvZA_lin_indexɊi[܂B
  //
  case STATE_DATA_RX:
	if (Uart_get_error()){						// ُLŁA
#ifdef _TIMOUT_DETECTION
	  Timer2_stop();							// Ԓߌv~
#endif
	  _lin_err = MSK_STATUS_ERRBIT;				// ޯĈُ׸ސݒ
	  _lin_status = MSK_STATUS_ERR;				// ُ׸ސݒ
	  _lin_state = STATE_CHECK_BREAK;			// Ԕԍ𓯊fԂɕύX
	  Uart_set_baudrate(UART_BAUDRATE_SYNC);	// USARTްڰĂ𓯊pɕύX
	} else {									// ُȂŁA
	  _lin_tab_data[_lin_cpt]=Uart_get_byte();	// M޲ĂɏՕɕۑ
	  _lin_cpt++;								// ɏՕʒuwqis
	  if(_lin_cpt == _lin_index){				// w萔BŁA
		_lin_crc  =  LIN_CalcChecksum();		// ьvZ
		_lin_state = STATE_CRC_RX;				// ԔԍюMԂɕύX
	  }
	}
	break;

  // --- STATE_DATA_TX:
  //
  // ̏Ԃ͎Ə]̗uŎgp܂(]ƕ)B
  // ̒iK͒Ooް ޲ĂsłȂƂ؂A޲Ă܂B
  //
  // : M޲ĐvZA_lin_indexɊi[܂B
  //
  case STATE_DATA_TX:
	if (Uart_get_error()){						// ُLŁA
#ifdef _TIMOUT_DETECTION
	  Timer2_stop();							// Ԓߌv~
#endif
	  _lin_err = MSK_STATUS_ERRBIT;				// ޯĈُ׸ސݒ
	  _lin_status = MSK_STATUS_ERR;				// ُ׸ސݒ
	  _lin_state = STATE_CHECK_BREAK;			// Ԕԍ𓯊fԂɕύX
	  Uart_set_baudrate(UART_BAUDRATE_SYNC);	// USARTްڰĂ𓯊pɕύX
	}else if ((_lin_tab_data[ _lin_cpt-1 ] == Uart_get_byte())  ){	// ُȂŁAOlMŁA
	  if (_lin_index){							// M޲ėLŁA
		Uart_send_byte(_lin_tab_data[_lin_cpt]);	// ޲đM
		_lin_index--;							// M޲Čv팸
		_lin_cpt++;								// ɏՕʒuwqis
	  }else{									// ްMŁA
		Uart_send_byte( _lin_crc);				//  ޲đM
		_lin_state = STATE_CRC_TX;				// ԔԍёMԂɕύX
	  }
	}else{										// OMُŁA
#ifdef _TIMOUT_DETECTION
	  Timer2_stop();							// Ԓߌv~
#endif
	  _lin_err = MSK_STATUS_ERRBIT;				// ޯĈُ׸ސݒ
	  _lin_status = MSK_STATUS_ERR;				// ُ׸ސݒ
	  _lin_state = STATE_CHECK_BREAK;			// Ԕԍ𓯊fԂɕύX
	  Uart_set_baudrate(UART_BAUDRATE_SYNC);	// USARTްڰĂ𓯊pɕύX
	}
	break;

  // --- STATE_CRC_RX:
  //
  // ̏Ԃ͎Ə]̗uŎgp܂(]ƕ)B
  // ̒iK͗LтMꂽƂ؂܂B
  //
  // : тRXOKԂ܂B
  //
  case STATE_CRC_RX:
	if (Uart_get_error()) {						// ُLŁA
	  _lin_err = MSK_STATUS_ERRBIT;				// ޯĈُ׸ސݒ
	  _lin_status = MSK_STATUS_ERR;				// ُ׸ސݒ
	} else if ( ((_lin_crc) & (0x00FF)) != Uart_get_byte() ) {	// ُȂŁAѕsvŁA
	  _lin_err = MSK_STATUS_ERRCSUM;			// ь׸ސݒ
	  _lin_status = MSK_STATUS_ERR;				// ُ׸ސݒ
	}else{										// шvŁA
	  _lin_status = MSK_STATUS_RXOK;			// M튮׸ސݒ
	}
#ifdef _TIMOUT_DETECTION
	Timer2_stop();								// Ԓߌv~
#endif
	_lin_state = STATE_CHECK_BREAK;				// Ԕԍ𓯊fԂɕύX
	Uart_set_baudrate(UART_BAUDRATE_SYNC);		// USARTްڰĂ𓯊pɕύX
	break;

  // --- STATE_CRC_TX:
  //
  // ̏Ԃ͎Ə]̗uŎgp܂(]ƕ)B
  // ̒iK ޲ĂoꂽƂ؂܂B
  //
  // : тTXOKԂ܂B
  //
  case STATE_CRC_TX:
	if (Uart_get_error()) {						// ُLŁA(ڰݸވُ(~ޯ))
	  _lin_err = MSK_STATUS_ERRBIT;				// ޯĈُ׸ސݒ
	  _lin_status = MSK_STATUS_ERR;				// ُ׸ސݒ
	}else  if (((_lin_crc) & 0xFF) != Uart_get_byte()){	// ُȂŁAlƍsvŁA
	  _lin_err = MSK_STATUS_ERRCSUM;			// ь׸ސݒ
	  _lin_status = MSK_STATUS_ERR;				// ُ׸ސݒ
	}else{										// lƍvŁA
	  _lin_status = MSK_STATUS_TXOK;			// M튮׸ސݒ
	}
#ifdef _TIMOUT_DETECTION
	Timer2_stop();								// Ԓߌv~
#endif
	_lin_state = STATE_CHECK_BREAK;				// Ԕԍ𓯊fԂɕύX
	Uart_set_baudrate(UART_BAUDRATE_SYNC);		// USARTްڰĂ𓯊pɕύX
	break;

  // --- STATE_SLEEP:
  //
  // ̏Ԃ͎Ə]̗uŎgp܂B
  // ̒iK͐킪x~Ԃł邱Ƃ̋L^Ɏgp܂B
  //
#ifdef _SLEEP_TIMOUT_DETECTION
  case STATE_SLEEP:
	_lin_err = MSK_STATUS_SLEEP_MODE;			// x~׸ސݒ
	_lin_status = MSK_STATUS_ERR;				// ُ׸ސݒ

	if( Uart_get_byte()==0x80) {				// NMŁA
#if LIN_CONFIG == 0						// 1:]u, 0:呕u
	  lin_master_in_sleep_mode = 0;				// 呕ux~׸މ
#elif LIN_CONFIG == 1					// 1:]u, 0:呕u
	  NoBusActivityFlag = 0;					// ޽Ȃ׸މ
	  SleepCtr = 0;								// x~Ԓߌv평
#else
#error "  "
#endif
	  _lin_status = MSK_STATUS_RXOK;			// M튮׸ސݒ
	  _lin_err = MSK_STATUS_SLEEP_MODE;			// x~׸ސݒ
	  LINSleepFlag = 0;							// LINx~׸މ
	  _lin_state = STATE_CHECK_BREAK;			// Ԕԍ𓯊fԂɕύX
	  Uart_set_baudrate(UART_BAUDRATE_SYNC);	// USARTްڰĂ𓯊pɕύX
	}
	break;
#endif

  default:
#ifdef _TIMOUT_DETECTION
	Timer2_stop();								// ڰюԒߌv~
#endif
	_lin_state = STATE_CHECK_BREAK;				// Ԕԍ𓯊fԂɕύX
	Uart_set_baudrate(UART_BAUDRATE_SYNC);		// USARTްڰĂ𓯊pɕύX
	break;

  } // ԔԍɂCASEI
} // USARTM荞ݏI

//! ̊֐͊S6ޯLINʎqDLC(ް)𒊏oconfig.ḩق
//! `ĂȂAްɉĎԒߌoJn܂B
//!
//! @warning :
//!
//! @param	_lin_id	è ޯĂLIN V1.3ʎq
//!
//! @return	_lin_index	8ޯĂłް
//!						2:ް=2޲
//!						4:ް=4޲
//!						8:ް=8޲
//!
U8 Lin_dlctonbyte(U8 _lin_id){
  _lin_index = (_lin_id&0x30) >>4;				// ްޯĂLSBֈړ
#ifdef _TIMOUT_DETECTION
  Timer2_stop();								// 擪Ԓߌv~
#endif
  if (_lin_index < 2){							// DLC=00܂01ŁA
#ifdef _TIMOUT_DETECTION
    Timer2_start(TIMEOUT_RESPONSE_2DATA,2);		// 2޲ ްԒߌvJn
#endif
    _lin_index = 2;								// ޲Đ=2ݒ
  }else if (2 == _lin_index){					// DLC=10ŁA
#ifdef _TIMOUT_DETECTION
    Timer2_start(TIMEOUT_RESPONSE_4DATA,4);		// 4޲ ްԒߌvJn
#endif
    _lin_index = 4;								// ޲Đ=4ݒ
  }else{
#ifdef _TIMOUT_DETECTION
    Timer2_start(TIMEOUT_RESPONSE_8DATA,8);		// 8޲ ްԒߌvJn
#endif
    _lin_index = 8;								// ޲Đ=8ݒ
  }
  return _lin_index;							// ޲ĐƋɕA
}

//! ̊֐USARTްڰ ڼ޽܂B
//!
//! @warning :
//!
//! @param	expected_baudrate	USARTްڰ(ްĂB)
//!
//! @return	Ȃ
//!
void Uart_set_baudrate(U16 expected_baudrate ) {
  UBRR =  expected_baudrate;
}

//! ̊֐͎呕uM߂config.ḩقŒ`Ăΐ擪ԒߌoJn܂B
//!
//! @warning :
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void Lin_cmdm_txdata(void){
#ifdef _TIMOUT_DETECTION
  Timer2_start(TIMEOUT_M_HEADER,0);					// 擪ԒߌvJn
#endif
  Uart_set_baudrate(UART_BAUDRATE_SYNC_MASTER);		// USARTްڰĂ呕upɕύX
  Uart_send_byte(0);								// fM
  _lin_status = MSK_STATUS_BSY;						// Z׸ސݒ
  _lin_cmd =LIN_CF_M_TX;							// 呕uMԒlݒ
}

//! ̊֐͎呕uM߂config.ḩقŒ`Ăΐ擪ԒߌoJn܂B
//!
//! @warning :
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void Lin_cmdm_rxdata(void){
#ifdef _TIMOUT_DETECTION
  Timer2_start(TIMEOUT_M_HEADER,0);					// 擪ԒߌvJn
#endif
  Uart_set_baudrate(UART_BAUDRATE_SYNC_MASTER);		// USARTްڰĂ呕upɕύX
  Uart_send_byte(0);								// fM
  _lin_status = MSK_STATUS_BSY;						// Z׸ސݒ
  _lin_cmd =LIN_CF_M_RX;							// 呕uMԒlݒ
}

//! ̊֐LINʰ޳s܂B
//! 1-USART
//! 2-LINM
//! 3-M
//! 4-USARTM荞݋
//!
//! @warning :
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void Lin_hw_init(void) {
  Uart_hw_init(MSK_UART_8BIT);						// USARTڰь`ԏ
  ENABLE_LIN();										// LIN
  UCSRB = MSK_UART_ENABLE_IT_RX + MSK_UART_ENABLE_RX + MSK_UART_ENABLE_TX;	// M,M,M荞݋
}
